/// <reference types="react" />
import { CSSObject } from "./types";
export { CSSObject };
export type { CSSInterpolation, Css, Cx, CxArg } from "./types";
/** @see <https://docs.tss-react.dev/api-references> */
export { useCssAndCx } from "./cssAndCx";
export { useMergedClasses } from "./mergeClasses";
import { createMakeStyles } from "./makeStyles";
export { createMakeStyles };
import { createWithStyles } from "./withStyles";
export { createWithStyles };
/** @see <https://docs.tss-react.dev/api-references/keyframes> */
export { keyframes } from "@emotion/react";
/** @see <https://docs.tss-react.dev/api-references/globalstyles> */
export { GlobalStyles } from "./GlobalStyles";
/** @see <https://docs.tss-react.dev/cache> */
export { getTssDefaultEmotionCache, TssCacheProvider } from "./cache";
/** @see <https://docs.tss-react.dev/api-references/makestyles-usestyles> */
export declare function createMakeAndWithStyles<Theme, CustomObject = CSSObject>(params: {
    useTheme: () => Theme;
    customObjectToCSSObject?: (params: {
        customObject: CustomObject;
        theme: Theme;
    }) => CSSObject;
}): {
    withStyles: <C extends keyof import("react").ReactHTML | import("./tools/ReactComponent").ReactComponent<any>, Props extends C extends import("./tools/ReactComponent").ReactComponent<infer P> ? P : C extends keyof import("react").ReactHTML ? import("react").ReactHTML[C] extends import("./tools/ReactComponent").ReactComponent<infer P_1> ? NonNullable<P_1> : never : never, CssObjectByRuleName extends Props extends {
        classes?: Partial<infer ClassNameByRuleName> | undefined;
    } ? { [RuleName in keyof ClassNameByRuleName]?: CSSObject | undefined; } & {
        [mediaQuery: `@media${string}`]: { [RuleName_1 in keyof ClassNameByRuleName]?: CSSObject | undefined; };
    } : {
        root: CSSObject;
    } & {
        [mediaQuery: `@media${string}`]: {
            root: CSSObject;
        };
    }>(Component: C, customObjectByRuleNameOrGetCustomObjectByRuleName: (CssObjectByRuleName & {
        [mediaQuery: `@media${string}`]: { [Key in keyof CssObjectByRuleName]?: CSSObject | undefined; };
    }) | ((theme: Theme, props: Props, classes: Record<Exclude<keyof CssObjectByRuleName, `@media${string}`>, string>) => CssObjectByRuleName), params?: {
        name?: string | Record<string, unknown> | undefined;
    } | undefined) => C extends keyof import("react").ReactHTML ? import("react").ReactHTML[C] : C;
    makeStyles: <Params = void, RuleNameSubsetReferencableInNestedSelectors extends string = never>(params?: {
        name?: string | Record<string, unknown> | undefined;
    } | undefined) => <RuleName_2 extends string>(customObjectByRuleNameOrGetCustomObjectByRuleName: Record<RuleName_2, CustomObject> | ((theme: Theme, params: Params, classes: Record<RuleNameSubsetReferencableInNestedSelectors, string>) => Record<RuleNameSubsetReferencableInNestedSelectors | RuleName_2, CustomObject>)) => (params: Params, styleOverrides?: {
        props: {
            classes?: Record<string, string> | undefined;
        } & Record<string, unknown>;
        ownerState?: Record<string, unknown> | undefined;
    } | undefined) => {
        classes: Record<RuleName_2, string>;
        theme: Theme;
        css: import("./types").Css;
        cx: import("./types").Cx;
    };
    useStyles: () => {
        theme: Theme;
        css: import("./types").Css;
        cx: import("./types").Cx;
    };
};
